blob: c03f57b227a8ae0c37c0630532738ff6a414d3cc [file] [log] [blame]
garciadeblasd8bc5c32018-05-09 17:37:56 +02001#!/bin/bash
garciadeblasd8bc5c32018-05-09 17:37:56 +02002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
garciadeblas0bc87522021-10-20 22:16:17 +020014#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015
16function usage(){
garciadeblas0bc87522021-10-20 22:16:17 +020017 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020018 echo -e "usage: $0 [OPTIONS]"
19 echo -e "Install OSM from binaries or source code (by default, from binaries)"
20 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000021 echo -e " -h / --help: print this help"
22 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblasd8bc5c32018-05-09 17:37:56 +020023 echo -e " -r <repo>: use specified repository name for osm packages"
24 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
25 echo -e " -u <repo base>: use specified repository url for osm packages"
26 echo -e " -k <repo key>: use specified repository public key url"
27 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
28 echo -e " -b master (main dev branch)"
29 echo -e " -b v2.0 (v2.0 branch)"
30 echo -e " -b tags/v1.1.0 (a specific tag)"
31 echo -e " ..."
garciadeblas0bc87522021-10-20 22:16:17 +020032 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
garciadeblas325032a2023-04-13 18:07:44 +020033 echo -e " -s <namespace> namespace when installed using k8s, default is osm"
Mike Marchettib8420852018-09-13 13:45:06 -040034 echo -e " -H <VCA host> use specific juju host controller IP"
35 echo -e " -S <VCA secret> use VCA/juju secret key"
garciadeblasaa3ddf42019-04-04 19:04:32 +020036 echo -e " -P <VCA pubkey> use VCA/juju public key file"
Adam Israel5ddc97f2019-09-03 18:11:12 -040037 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
magnussonl1bbe9452020-02-25 13:43:17 +010038 echo -e " --pla: install the PLA module for placement support"
garciadeblas7b53d262022-11-04 23:18:48 +010039 echo -e " --ng-sa: install Airflow and Pushgateway to get VNF and NS status (experimental)"
beierlmcca93642021-05-03 16:29:14 -040040 echo -e " -m <MODULE>: install OSM but only rebuild or pull the specified docker images (NG-UI, NBI, LCM, RO, MON, POL, PLA, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, NONE)"
garciadeblasfa3eb332022-11-15 14:11:56 +010041 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (k8s_monitor, ng-sa)"
Antonio Marsico75a38c72020-12-21 17:29:42 +010042 echo -e " -O <openrc file path/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020043 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
Antonio Marsico75a38c72020-12-21 17:29:42 +010044 echo -e " -f <path to SSH public key>: Public SSH key to use to deploy OSM to OpenStack"
45 echo -e " -F <path to cloud-init file>: Cloud-Init userdata file to deploy OSM to OpenStack"
garciadeblase990f662018-05-18 11:43:39 +020046 echo -e " -D <devops path> use local devops installation path"
Mike Marchettib8420852018-09-13 13:45:06 -040047 echo -e " -w <work dir> Location to store runtime installation"
Mike Marchetti13d76c82018-09-19 15:00:36 -040048 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020049 echo -e " -l: LXD cloud yaml file"
50 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020051 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000052 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
53 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
54 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas0bc87522021-10-20 22:16:17 +020055 echo -e " --debug: debug mode"
garciadeblas9a510862021-04-21 14:15:56 +020056 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
garciadeblas0bc87522021-10-20 22:16:17 +020057 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
David Garcia79f4f532020-04-07 12:59:34 +020058 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblasa3e26612018-05-30 17:58:55 +020059 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
Mike Marchettib8420852018-09-13 13:45:06 -040060 echo -e " --nojuju: do not juju, assumes already installed"
61 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
62 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
63 echo -e " --nohostclient: do not install the osmclient"
garciadeblase990f662018-05-18 11:43:39 +020064 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
65 echo -e " --source: install OSM from source code using the latest stable tag"
garciadeblasd8bc5c32018-05-09 17:37:56 +020066 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
Mike Marchettida8a9c42018-10-01 15:25:15 -040067 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
romeromonser599d5e22020-03-06 10:23:29 +010068 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +020069 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblasd8bc5c32018-05-09 17:37:56 +020070 echo -e " --showopts: print chosen options and exit (only for debugging)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020071 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
72 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
73 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020074 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
aticig5d19ac22022-05-06 13:46:22 +030075 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020076 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020077 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
78 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
David Garcia4bd2bf02021-05-05 19:01:43 +020079 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020080 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
beierlmf2782c52020-11-05 17:04:05 -050081 echo -e " [--tag]: Docker image tag. (--charmed option)"
82 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
garciadeblas0bc87522021-10-20 22:16:17 +020083 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +020084}
85
Mike Marchettib8420852018-09-13 13:45:06 -040086# takes a juju/accounts.yaml file and returns the password specific
Adam Israel8232e562018-11-21 16:47:45 -050087# for a controller. I wrote this using only bash tools to minimize
Mike Marchettib8420852018-09-13 13:45:06 -040088# additions of other packages
89function parse_juju_password {
garciadeblas0bc87522021-10-20 22:16:17 +020090 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
91 password_file="${HOME}/.local/share/juju/accounts.yaml"
92 local controller_name=$1
93 local s='[[:space:]]*' w='[a-zA-Z0-9_-]*' fs=$(echo @|tr @ '\034')
94 sed -ne "s|^\($s\):|\1|" \
95 -e "s|^\($s\)\($w\)$s:$s[\"']\(.*\)[\"']$s\$|\1$fs\2$fs\3|p" \
96 -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p" $password_file |
97 awk -F$fs -v controller=$controller_name '{
98 indent = length($1)/2;
99 vname[indent] = $2;
100 for (i in vname) {if (i > indent) {delete vname[i]}}
101 if (length($3) > 0) {
102 vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
103 if (match(vn,controller) && match($2,"password")) {
104 printf("%s",$3);
105 }
106 }
107 }'
108 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
109}
110
111function set_vca_variables() {
112 OSM_VCA_CLOUDNAME="lxd-cloud"
113 [ -n "$OSM_VCA_HOST" ] && OSM_VCA_CLOUDNAME="localhost"
114 if [ -z "$OSM_VCA_HOST" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200115 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_NAMESPACE"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
garciadeblas0bc87522021-10-20 22:16:17 +0200116 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
117 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
118 fi
119 if [ -z "$OSM_VCA_SECRET" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200120 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $OSM_NAMESPACE)
garciadeblas0bc87522021-10-20 22:16:17 +0200121 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $CONTROLLER_NAME)
122 [ -z "$OSM_VCA_SECRET" ] && FATAL "Cannot obtain juju secret"
123 fi
124 if [ -z "$OSM_VCA_PUBKEY" ]; then
125 OSM_VCA_PUBKEY=$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)
126 [ -z "$OSM_VCA_PUBKEY" ] && FATAL "Cannot obtain juju public key"
127 fi
128 if [ -z "$OSM_VCA_CACERT" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200129 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $OSM_NAMESPACE '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
garciadeblas0bc87522021-10-20 22:16:17 +0200130 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $CONTROLLER_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
131 [ -z "$OSM_VCA_CACERT" ] && FATAL "Cannot obtain juju CA certificate"
132 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400133}
134
Benjamin Diazba2cca92018-11-08 21:07:15 -0300135function generate_secret() {
garciadeblas0bc87522021-10-20 22:16:17 +0200136 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Benjamin Diazba2cca92018-11-08 21:07:15 -0300137 head /dev/urandom | tr -dc A-Za-z0-9 | head -c 32
garciadeblas0bc87522021-10-20 22:16:17 +0200138 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
calvinosanc10c82da02020-08-17 11:45:15 +0200139}
140
beierlm2ce2b002021-12-07 16:02:22 -0500141function check_packages() {
142 NEEDED_PACKAGES="$1"
143 echo -e "Checking required packages: ${NEEDED_PACKAGES}"
144 for PACKAGE in ${NEEDED_PACKAGES} ; do
garciadeblas835088e2022-01-28 11:25:18 +0100145 dpkg -L ${PACKAGE}
beierlm2ce2b002021-12-07 16:02:22 -0500146 if [ $? -ne 0 ]; then
garciadeblas835088e2022-01-28 11:25:18 +0100147 echo -e "Package ${PACKAGE} is not installed."
148 echo -e "Updating apt-cache ..."
beierlm2ce2b002021-12-07 16:02:22 -0500149 sudo apt-get update
garciadeblas835088e2022-01-28 11:25:18 +0100150 echo -e "Installing ${PACKAGE} ..."
beierlm2ce2b002021-12-07 16:02:22 -0500151 sudo apt-get install -y ${PACKAGE} || FATAL "failed to install ${PACKAGE}"
152 fi
153 done
154 echo -e "Required packages are present: ${NEEDED_PACKAGES}"
155}
156
garciadeblasd8bc5c32018-05-09 17:37:56 +0200157function ask_user(){
158 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
159 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
160 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
garciadeblas0bc87522021-10-20 22:16:17 +0200161 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200162 read -e -p "$1" USER_CONFIRMATION
163 while true ; do
164 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
165 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
166 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
167 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
168 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
169 done
garciadeblas0bc87522021-10-20 22:16:17 +0200170 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200171}
172
garciadeblasd8bc5c32018-05-09 17:37:56 +0200173function install_osmclient(){
garciadeblas0bc87522021-10-20 22:16:17 +0200174 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200175 CLIENT_RELEASE=${RELEASE#"-R "}
176 CLIENT_REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
177 CLIENT_REPOSITORY=${REPOSITORY#"-r "}
garciadeblasd8bc5c32018-05-09 17:37:56 +0200178 CLIENT_REPOSITORY_BASE=${REPOSITORY_BASE#"-u "}
179 key_location=$CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE/$CLIENT_REPOSITORY_KEY
garciadeblas0bc87522021-10-20 22:16:17 +0200180 curl $key_location | sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add -
garciadeblas078f5982019-11-27 15:06:06 +0100181 sudo add-apt-repository -y "deb [arch=amd64] $CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE $CLIENT_REPOSITORY osmclient IM"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200182 sudo apt-get update
garciadeblas078f5982019-11-27 15:06:06 +0100183 sudo apt-get install -y python3-pip
184 sudo -H LC_ALL=C python3 -m pip install -U pip
garciadeblasa9954892020-01-22 16:05:05 +0100185 sudo -H LC_ALL=C python3 -m pip install -U python-magic pyangbind verboselogs
garciadeblasda89ee72019-11-28 02:19:59 +0100186 sudo apt-get install -y python3-osm-im python3-osmclient
beierlm920d7562021-04-21 05:13:53 -0400187 if [ -f /usr/lib/python3/dist-packages/osm_im/requirements.txt ]; then
beierlm021b3072021-04-27 14:33:24 -0400188 python3 -m pip install -r /usr/lib/python3/dist-packages/osm_im/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400189 fi
190 if [ -f /usr/lib/python3/dist-packages/osmclient/requirements.txt ]; then
garciadeblas56005542022-08-29 14:56:02 +0200191 sudo apt-get install -y libcurl4-openssl-dev libssl-dev libmagic1
beierlm021b3072021-04-27 14:33:24 -0400192 python3 -m pip install -r /usr/lib/python3/dist-packages/osmclient/requirements.txt
beierlm920d7562021-04-21 05:13:53 -0400193 fi
garciadeblasd8bc5c32018-05-09 17:37:56 +0200194 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_HOSTNAME=`lxc list | awk '($2=="SO-ub"){print $6}'`
195 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_RO_HOSTNAME=`lxc list | awk '($2=="RO"){print $6}'`
garciadeblasd8bc5c32018-05-09 17:37:56 +0200196 echo -e "\nOSM client installed"
garciadeblasc3226982018-11-27 11:32:47 +0100197 if [ -z "$INSTALL_LIGHTWEIGHT" ]; then
198 echo -e "You might be interested in adding the following OSM client env variables to your .bashrc file:"
199 echo " export OSM_HOSTNAME=${OSM_HOSTNAME}"
200 echo " export OSM_RO_HOSTNAME=${OSM_RO_HOSTNAME}"
201 else
202 echo -e "OSM client assumes that OSM host is running in localhost (127.0.0.1)."
203 echo -e "In case you want to interact with a different OSM host, you will have to configure this env variable in your .bashrc file:"
204 echo " export OSM_HOSTNAME=<OSM_host>"
205 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200206 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200207 return 0
208}
209
garciadeblas453d4582020-12-16 19:03:10 +0100210function docker_login() {
garciadeblas0bc87522021-10-20 22:16:17 +0200211 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100212 echo "Docker login"
garciadeblas0bc87522021-10-20 22:16:17 +0200213 [ -z "${DEBUG_INSTALL}" ] || DEBUG "Docker registry user: ${DOCKER_REGISTRY_USER}"
214 sg docker -c "docker login -u ${DOCKER_REGISTRY_USER} -p ${DOCKER_REGISTRY_PASSWORD} --password-stdin"
215 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100216}
217
garciadeblas53b217f2023-05-04 17:57:47 +0200218function pull_docker_images() {
garciadeblas0bc87522021-10-20 22:16:17 +0200219 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas53b217f2023-05-04 17:57:47 +0200220 echo "Pulling docker images"
garciadeblas453d4582020-12-16 19:03:10 +0100221 [ -n "${DOCKER_REGISTRY_URL}" ] && docker_login
Michael Marchettiee374142018-08-02 22:47:16 +0200222
garciadeblas53b217f2023-05-04 17:57:47 +0200223 echo "Pulling non-OSM docker images"
garciadeblas0e596bc2018-05-28 16:04:42 +0200224 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q KAFKA ; then
225 sg docker -c "docker pull wurstmeister/zookeeper" || FATAL "cannot get zookeeper docker image"
Benjamin Diazaa0af712018-10-04 14:02:34 -0300226 sg docker -c "docker pull wurstmeister/kafka:${KAFKA_TAG}" || FATAL "cannot get kafka docker image"
garciadeblas0e596bc2018-05-28 16:04:42 +0200227 fi
Mike Marchettida8a9c42018-10-01 15:25:15 -0400228
lavado60216242018-10-10 23:44:28 +0200229 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS ; then
230 sg docker -c "docker pull prom/prometheus:${PROMETHEUS_TAG}" || FATAL "cannot get prometheus docker image"
231 fi
232
garciadeblasfc5bb142019-12-10 10:49:12 +0100233 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS-CADVISOR ; then
234 sg docker -c "docker pull google/cadvisor:${PROMETHEUS_CADVISOR_TAG}" || FATAL "cannot get prometheus cadvisor docker image"
235 fi
236
lavado6ad812e2019-11-29 10:58:58 -0500237 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q GRAFANA ; then
238 sg docker -c "docker pull grafana/grafana:${GRAFANA_TAG}" || FATAL "cannot get grafana docker image"
garciadeblas0ab16612022-02-22 14:23:57 +0100239 sg docker -c "docker pull kiwigrid/k8s-sidecar:${KIWIGRID_K8S_SIDECAR_TAG}" || FATAL "cannot get kiwigrid k8s-sidecar docker image"
garciadeblasfc5bb142019-12-10 10:49:12 +0100240 fi
lavado6ad812e2019-11-29 10:58:58 -0500241
garciadeblas4a83e6e2018-12-04 14:55:09 +0100242 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NBI || echo $TO_REBUILD | grep -q KEYSTONE-DB ; then
lavado9a8df7c2018-10-24 09:35:34 -0500243 sg docker -c "docker pull mariadb:${KEYSTONEDB_TAG}" || FATAL "cannot get keystone-db docker image"
244 fi
245
garciadeblas4a83e6e2018-12-04 14:55:09 +0100246 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q RO ; then
247 sg docker -c "docker pull mysql:5" || FATAL "cannot get mysql docker image"
248 fi
249
garciadeblas53b217f2023-05-04 17:57:47 +0200250 echo "Pulling OSM docker images"
251 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA osmclient Airflow; do
252 module_lower=${module,,}
253 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
254 continue
255 fi
256 module_tag="${OSM_DOCKER_TAG}"
257 if [ -n "${MODULE_DOCKER_TAG}" ] && echo $TO_REBUILD | grep -q $module ; then
258 module_tag="${MODULE_DOCKER_TAG}"
259 fi
260 echo "Pulling ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag} docker image"
261 sg docker -c "docker pull ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag}" || FATAL "cannot pull $module docker image"
262 done
263
264 echo "Finished pulling docker images"
265 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
266}
267
268function generate_docker_images() {
269 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
270 echo "Generating docker images"
271 _build_from=$COMMIT_ID
272 [ -z "$_build_from" ] && _build_from="latest"
273 echo "OSM Docker images generated from $_build_from"
274 LWTEMPDIR="$(mktemp -d -q --tmpdir "installosmlight.XXXXXX")"
275 trap 'rm -rf "${LWTEMPDIR}"' EXIT
276 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA; do
277 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q ${module} ; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000278 module_lower=${module,,}
garciadeblas7f1e1042020-11-30 14:07:03 +0000279 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
280 continue
281 fi
garciadeblas53b217f2023-05-04 17:57:47 +0200282 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/$module
283 git -C ${LWTEMPDIR}/${module} checkout ${COMMIT_ID}
284 sg docker -c "docker build ${LWTEMPDIR}/${module} -f ${LWTEMPDIR}/${module}/docker/Dockerfile -t ${DOCKER_USER}/${module_lower} --no-cache" || FATAL "cannot build ${module} docker image"
vijaynag4b57d462020-06-08 14:23:10 +0000285 fi
garciadeblas53b217f2023-05-04 17:57:47 +0200286 done
287 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q osmclient; then
288 BUILD_ARGS+=(--build-arg REPOSITORY="$REPOSITORY")
289 BUILD_ARGS+=(--build-arg RELEASE="$RELEASE")
290 BUILD_ARGS+=(--build-arg REPOSITORY_KEY="$REPOSITORY_KEY")
291 BUILD_ARGS+=(--build-arg REPOSITORY_BASE="$REPOSITORY_BASE")
292 sg docker -c "docker build -t ${DOCKER_USER}/osmclient ${BUILD_ARGS[@]} -f $OSM_DEVOPS/docker/osmclient ."
Mike Marchettib8420852018-09-13 13:45:06 -0400293 fi
garciadeblas53b217f2023-05-04 17:57:47 +0200294 echo "Finished generation of docker images"
garciadeblas0bc87522021-10-20 22:16:17 +0200295 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200296}
297
garciadeblas5b857d32018-05-24 18:37:58 +0200298function cmp_overwrite() {
garciadeblas0bc87522021-10-20 22:16:17 +0200299 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas5b857d32018-05-24 18:37:58 +0200300 file1="$1"
301 file2="$2"
302 if ! $(cmp "${file1}" "${file2}" >/dev/null 2>&1); then
303 if [ -f "${file2}" ]; then
Mike Marchettib8420852018-09-13 13:45:06 -0400304 ask_user "The file ${file2} already exists. Overwrite (y/N)? " n && cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200305 else
Mike Marchettib8420852018-09-13 13:45:06 -0400306 cp -b ${file1} ${file2}
garciadeblas5b857d32018-05-24 18:37:58 +0200307 fi
308 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200309 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400310}
311
312function generate_k8s_manifest_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200313 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
beierlma4a37f72020-06-26 12:55:01 -0400314 #Kubernetes resources
garciadeblas0bc87522021-10-20 22:16:17 +0200315 sudo cp -bR ${OSM_DEVOPS}/installers/docker/osm_pods $OSM_DOCKER_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200316 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
beierlma4a37f72020-06-26 12:55:01 -0400317}
318
garciadeblasd8bc5c32018-05-09 17:37:56 +0200319function generate_docker_env_files() {
garciadeblas0bc87522021-10-20 22:16:17 +0200320 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200321 echo "Doing a backup of existing env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200322 sudo cp $OSM_DOCKER_WORK_DIR/keystone-db.env{,~}
323 sudo cp $OSM_DOCKER_WORK_DIR/keystone.env{,~}
324 sudo cp $OSM_DOCKER_WORK_DIR/lcm.env{,~}
325 sudo cp $OSM_DOCKER_WORK_DIR/mon.env{,~}
326 sudo cp $OSM_DOCKER_WORK_DIR/nbi.env{,~}
327 sudo cp $OSM_DOCKER_WORK_DIR/pol.env{,~}
328 sudo cp $OSM_DOCKER_WORK_DIR/ro-db.env{,~}
329 sudo cp $OSM_DOCKER_WORK_DIR/ro.env{,~}
garciadeblas7b53d262022-11-04 23:18:48 +0100330 if [ -n "${INSTALL_NGSA}" ]; then
331 sudo cp $OSM_DOCKER_WORK_DIR/ngsa.env{,~}
garciadeblasbacdfa82023-04-04 10:52:46 +0200332 sudo cp $OSM_DOCKER_WORK_DIR/webhook-translator.env{,~}
garciadeblas7b53d262022-11-04 23:18:48 +0100333 fi
garciadeblasf9f6d9d2019-10-16 09:33:35 +0200334
garciadeblasd8bc5c32018-05-09 17:37:56 +0200335 echo "Generating docker env files"
Benjamin Diazba2cca92018-11-08 21:07:15 -0300336 # LCM
337 if [ ! -f $OSM_DOCKER_WORK_DIR/lcm.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200338 echo "OSMLCM_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300339 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400340
Benjamin Diazba2cca92018-11-08 21:07:15 -0300341 if ! grep -Fq "OSMLCM_VCA_HOST" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200342 echo "OSMLCM_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300343 else
garciadeblas0bc87522021-10-20 22:16:17 +0200344 sudo sed -i "s|OSMLCM_VCA_HOST.*|OSMLCM_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300345 fi
346
347 if ! grep -Fq "OSMLCM_VCA_SECRET" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200348 echo "OSMLCM_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300349 else
garciadeblas0bc87522021-10-20 22:16:17 +0200350 sudo sed -i "s|OSMLCM_VCA_SECRET.*|OSMLCM_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/lcm.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300351 fi
352
garciadeblasaa3ddf42019-04-04 19:04:32 +0200353 if ! grep -Fq "OSMLCM_VCA_PUBKEY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200354 echo "OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200355 else
garciadeblas0bc87522021-10-20 22:16:17 +0200356 sudo sed -i "s|OSMLCM_VCA_PUBKEY.*|OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasaa3ddf42019-04-04 19:04:32 +0200357 fi
358
Adam Israelbe7676a2019-10-02 16:10:53 -0400359 if ! grep -Fq "OSMLCM_VCA_CACERT" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200360 echo "OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400361 else
garciadeblas0bc87522021-10-20 22:16:17 +0200362 sudo sed -i "s|OSMLCM_VCA_CACERT.*|OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/lcm.env
Adam Israelbe7676a2019-10-02 16:10:53 -0400363 fi
Benjamin Diazba2cca92018-11-08 21:07:15 -0300364
David Garcia6cbfee12020-10-23 10:40:20 +0200365 if [ -n "$OSM_VCA_APIPROXY" ]; then
366 if ! grep -Fq "OSMLCM_VCA_APIPROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200367 echo "OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200368 else
garciadeblas0bc87522021-10-20 22:16:17 +0200369 sudo sed -i "s|OSMLCM_VCA_APIPROXY.*|OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia6cbfee12020-10-23 10:40:20 +0200370 fi
Adam Israel5ddc97f2019-09-03 18:11:12 -0400371 fi
372
garciadeblasa2e41842019-12-18 11:05:24 +0100373 if ! grep -Fq "OSMLCM_VCA_ENABLEOSUPGRADE" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200374 echo "# OSMLCM_VCA_ENABLEOSUPGRADE=false" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100375 fi
376
377 if ! grep -Fq "OSMLCM_VCA_APTMIRROR" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200378 echo "# OSMLCM_VCA_APTMIRROR=http://archive.ubuntu.com/ubuntu/" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
garciadeblasa2e41842019-12-18 11:05:24 +0100379 fi
380
David Garcia79f4f532020-04-07 12:59:34 +0200381 if ! grep -Fq "OSMLCM_VCA_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200382 echo "OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200383 else
garciadeblas0bc87522021-10-20 22:16:17 +0200384 sudo sed -i "s|OSMLCM_VCA_CLOUD.*|OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
David Garcia79f4f532020-04-07 12:59:34 +0200385 fi
386
beierlma4a37f72020-06-26 12:55:01 -0400387 if ! grep -Fq "OSMLCM_VCA_K8S_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200388 echo "OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400389 else
garciadeblas0bc87522021-10-20 22:16:17 +0200390 sudo sed -i "s|OSMLCM_VCA_K8S_CLOUD.*|OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
beierlma4a37f72020-06-26 12:55:01 -0400391 fi
garciadeblasfa3eb332022-11-15 14:11:56 +0100392 if [ -n "${OSM_BEHIND_PROXY}" ]; then
393 if ! grep -Fq "HTTP_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
394 echo "HTTP_PROXY=${HTTP_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
395 else
396 sudo sed -i "s|HTTP_PROXY.*|HTTP_PROXY=${HTTP_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
397 fi
398 if ! grep -Fq "HTTPS_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
399 echo "HTTPS_PROXY=${HTTPS_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
400 else
401 sudo sed -i "s|HTTPS_PROXY.*|HTTPS_PROXY=${HTTPS_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
402 fi
403 if ! grep -Fq "NO_PROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
404 echo "NO_PROXY=${NO_PROXY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/lcm.env
405 else
406 sudo sed -i "s|NO_PROXY.*|NO_PROXY=${NO_PROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
407 fi
408 fi
beierlma4a37f72020-06-26 12:55:01 -0400409
Benjamin Diazba2cca92018-11-08 21:07:15 -0300410 # RO
411 MYSQL_ROOT_PASSWORD=$(generate_secret)
Mike Marchettib8420852018-09-13 13:45:06 -0400412 if [ ! -f $OSM_DOCKER_WORK_DIR/ro-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200413 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro-db.env
garciadeblas5b857d32018-05-24 18:37:58 +0200414 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400415 if [ ! -f $OSM_DOCKER_WORK_DIR/ro.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200416 echo "RO_DB_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/ro.env
garciadeblas5b857d32018-05-24 18:37:58 +0200417 fi
tierno9ec1fe92020-11-25 13:16:51 +0000418 if ! grep -Fq "OSMRO_DATABASE_COMMONKEY" $OSM_DOCKER_WORK_DIR/ro.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200419 echo "OSMRO_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ro.env
tierno9ec1fe92020-11-25 13:16:51 +0000420 fi
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100421
Benjamin Diazba2cca92018-11-08 21:07:15 -0300422 # Keystone
Benjamin Diazba2cca92018-11-08 21:07:15 -0300423 KEYSTONE_DB_PASSWORD=$(generate_secret)
Eduardo Sousac50ed8f2019-04-08 17:17:54 +0100424 SERVICE_PASSWORD=$(generate_secret)
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100425 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone-db.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200426 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone-db.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100427 fi
428 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200429 echo "ROOT_DB_PASSWORD=${MYSQL_ROOT_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/keystone.env
430 echo "KEYSTONE_DB_PASSWORD=${KEYSTONE_DB_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
431 echo "SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee -a $OSM_DOCKER_WORK_DIR/keystone.env
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100432 fi
433
Benjamin Diazba2cca92018-11-08 21:07:15 -0300434 # NBI
Eduardo Sousae193dfd2018-09-21 11:37:49 +0100435 if [ ! -f $OSM_DOCKER_WORK_DIR/nbi.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200436 echo "OSMNBI_AUTHENTICATION_SERVICE_PASSWORD=${SERVICE_PASSWORD}" |sudo tee $OSM_DOCKER_WORK_DIR/nbi.env
437 echo "OSMNBI_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/nbi.env
Eduardo Sousa09a1e972018-09-21 11:06:32 +0100438 fi
439
Benjamin Diazba2cca92018-11-08 21:07:15 -0300440 # MON
441 if [ ! -f $OSM_DOCKER_WORK_DIR/mon.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200442 echo "OSMMON_KEYSTONE_SERVICE_PASSWORD=${SERVICE_PASSWORD}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
443 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
444 echo "OSMMON_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/mon" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300445 fi
446
447 if ! grep -Fq "OS_NOTIFIER_URI" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100448 echo "OS_NOTIFIER_URI=http://${OSM_DEFAULT_IP}:8662" |sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300449 else
garciadeblas45ab04c2022-11-25 10:59:03 +0100450 sudo sed -i "s|OS_NOTIFIER_URI.*|OS_NOTIFIER_URI=http://$OSM_DEFAULT_IP:8662|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300451 fi
452
453 if ! grep -Fq "OSMMON_VCA_HOST" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200454 echo "OSMMON_VCA_HOST=${OSM_VCA_HOST}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300455 else
garciadeblas0bc87522021-10-20 22:16:17 +0200456 sudo sed -i "s|OSMMON_VCA_HOST.*|OSMMON_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300457 fi
458
459 if ! grep -Fq "OSMMON_VCA_SECRET" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200460 echo "OSMMON_VCA_SECRET=${OSM_VCA_SECRET}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300461 else
garciadeblas0bc87522021-10-20 22:16:17 +0200462 sudo sed -i "s|OSMMON_VCA_SECRET.*|OSMMON_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/mon.env
Benjamin Diazba2cca92018-11-08 21:07:15 -0300463 fi
Mike Marchettib8420852018-09-13 13:45:06 -0400464
Adam Israel6d8adf32019-12-05 15:46:54 -0500465 if ! grep -Fq "OSMMON_VCA_CACERT" $OSM_DOCKER_WORK_DIR/mon.env; then
garciadeblas0bc87522021-10-20 22:16:17 +0200466 echo "OSMMON_VCA_CACERT=${OSM_VCA_CACERT}" | sudo tee -a $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500467 else
garciadeblas0bc87522021-10-20 22:16:17 +0200468 sudo sed -i "s|OSMMON_VCA_CACERT.*|OSMMON_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/mon.env
Adam Israel6d8adf32019-12-05 15:46:54 -0500469 fi
470
Benjamin Diaz04560882019-02-26 17:25:07 -0300471 # POL
472 if [ ! -f $OSM_DOCKER_WORK_DIR/pol.env ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200473 echo "OSMPOL_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/pol" | sudo tee -a $OSM_DOCKER_WORK_DIR/pol.env
Benjamin Diaz04560882019-02-26 17:25:07 -0300474 fi
475
garciadeblas7b53d262022-11-04 23:18:48 +0100476 # NG-SA
477 if [ -n "${INSTALL_NGSA}" ] && [ ! -f $OSM_DOCKER_WORK_DIR/ngsa.env ]; then
478 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | sudo tee -a $OSM_DOCKER_WORK_DIR/ngsa.env
479 fi
480
garciadeblasbacdfa82023-04-04 10:52:46 +0200481 # Webhook-translator
482 if [ -n "${INSTALL_NGSA}" ] && [ ! -f $OSM_DOCKER_WORK_DIR/webhook-translator.env ]; then
483 echo "AIRFLOW_HOST=airflow-webserver" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
484 echo "AIRFLOW_PORT=8080" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
485 echo "AIRFLOW_USER=admin" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
486 echo "AIRFLOW_PASS=admin" | sudo tee -a $OSM_DOCKER_WORK_DIR/webhook-translator.env
487 fi
488
garciadeblasd8bc5c32018-05-09 17:37:56 +0200489 echo "Finished generation of docker env files"
garciadeblas0bc87522021-10-20 22:16:17 +0200490 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530491}
492
493#creates secrets from env files which will be used by containers
494function kube_secrets(){
garciadeblas0bc87522021-10-20 22:16:17 +0200495 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas325032a2023-04-13 18:07:44 +0200496 kubectl create ns $OSM_NAMESPACE
497 kubectl create secret generic lcm-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/lcm.env
498 kubectl create secret generic mon-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/mon.env
499 kubectl create secret generic nbi-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/nbi.env
500 kubectl create secret generic ro-db-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/ro-db.env
501 kubectl create secret generic ro-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/ro.env
502 kubectl create secret generic keystone-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/keystone.env
503 kubectl create secret generic pol-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/pol.env
garciadeblas7b53d262022-11-04 23:18:48 +0100504 if [ -n "${INSTALL_NGSA}" ]; then
garciadeblas325032a2023-04-13 18:07:44 +0200505 kubectl create secret generic ngsa-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/ngsa.env
506 kubectl create secret generic webhook-translator-secret -n $OSM_NAMESPACE --from-env-file=$OSM_DOCKER_WORK_DIR/webhook-translator.env
garciadeblas7b53d262022-11-04 23:18:48 +0100507 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200508 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasf6ed60c2020-07-08 14:30:29 +0000509}
510
511#deploys osm pods and services
512function deploy_osm_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200513 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas325032a2023-04-13 18:07:44 +0200514 kubectl apply -n $OSM_NAMESPACE -f $OSM_K8S_WORK_DIR
garciadeblas0bc87522021-10-20 22:16:17 +0200515 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530516}
517
David Garciaa1376012020-10-19 15:42:42 +0200518#deploy charmed services
519function deploy_charmed_services() {
garciadeblas0bc87522021-10-20 22:16:17 +0200520 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas325032a2023-04-13 18:07:44 +0200521 juju add-model $OSM_NAMESPACE $OSM_VCA_K8S_CLOUDNAME
522 juju deploy ch:mongodb-k8s -m $OSM_NAMESPACE
garciadeblas0bc87522021-10-20 22:16:17 +0200523 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
David Garciaa1376012020-10-19 15:42:42 +0200524}
525
magnussonl1bbe9452020-02-25 13:43:17 +0100526function deploy_osm_pla_service() {
garciadeblas0bc87522021-10-20 22:16:17 +0200527 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
magnussonl1bbe9452020-02-25 13:43:17 +0100528 # corresponding to deploy_osm_services
garciadeblas325032a2023-04-13 18:07:44 +0200529 kubectl apply -n $OSM_NAMESPACE -f $OSM_DOCKER_WORK_DIR/osm_pla
garciadeblas0bc87522021-10-20 22:16:17 +0200530 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonser599d5e22020-03-06 10:23:29 +0100531}
532
garciadeblas7b53d262022-11-04 23:18:48 +0100533function install_osm_ngsa_service() {
534 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasd2d00c72022-11-25 17:21:46 +0100535 $OSM_DEVOPS/installers/install_ngsa.sh -d ${OSM_HELM_WORK_DIR} -D ${OSM_DEVOPS} -t ${OSM_DOCKER_TAG} ${DEBUG_INSTALL} || \
garciadeblas7b53d262022-11-04 23:18:48 +0100536 FATAL_TRACK install_osm_ngsa_service "install_ngsa.sh failed"
537 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
538}
539
vijaynag8339ed22019-07-25 17:10:58 +0530540function parse_yaml() {
garciadeblas0bc87522021-10-20 22:16:17 +0200541 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
vijaynag8339ed22019-07-25 17:10:58 +0530542 TAG=$1
garciadeblas7f1e1042020-11-30 14:07:03 +0000543 shift
544 services=$@
545 for module in $services; do
546 if [ "$module" == "pla" ]; then
547 if [ -n "$INSTALL_PLA" ]; then
garciadeblas7b53d262022-11-04 23:18:48 +0100548 echo "Updating K8s manifest file from opensourcemano\/pla:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/pla:${TAG}"
garciadeblas0bc87522021-10-20 22:16:17 +0200549 sudo sed -i "s#opensourcemano/pla:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/pla:${TAG}#g" ${OSM_DOCKER_WORK_DIR}/osm_pla/pla.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000550 fi
551 else
garciadeblas7b53d262022-11-04 23:18:48 +0100552 image=${module}
553 if [ "$module" == "ng-prometheus" ]; then
554 image="prometheus"
garciadeblas0e49b4a2023-04-17 12:38:17 +0200555 elif [ "$module" == "ng-mon" ]; then
556 image="mon"
garciadeblas7b53d262022-11-04 23:18:48 +0100557 fi
558 echo "Updating K8s manifest file from opensourcemano\/${image}:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/${image}:${TAG}"
559 sudo sed -i "s#opensourcemano/${image}:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/${image}:${TAG}#g" ${OSM_K8S_WORK_DIR}/${module}.yaml
garciadeblas7f1e1042020-11-30 14:07:03 +0000560 fi
vijaynag8339ed22019-07-25 17:10:58 +0530561 done
garciadeblas0bc87522021-10-20 22:16:17 +0200562 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas7f1e1042020-11-30 14:07:03 +0000563}
564
565function update_manifest_files() {
garciadeblas0e49b4a2023-04-17 12:38:17 +0200566 osm_services="nbi lcm ro pol mon ng-mon ng-ui keystone pla prometheus ng-prometheus"
garciadeblas7f1e1042020-11-30 14:07:03 +0000567 list_of_services=""
568 for module in $osm_services; do
569 module_upper="${module^^}"
garciadeblas7f1e1042020-11-30 14:07:03 +0000570 if ! echo $TO_REBUILD | grep -q $module_upper ; then
571 list_of_services="$list_of_services $module"
572 fi
573 done
garciadeblas89c5f552022-11-24 20:16:57 +0100574 if [ ! "$OSM_DOCKER_TAG" == "13" ]; then
garciadeblas7f1e1042020-11-30 14:07:03 +0000575 parse_yaml $OSM_DOCKER_TAG $list_of_services
576 fi
577 if [ -n "$MODULE_DOCKER_TAG" ]; then
578 parse_yaml $MODULE_DOCKER_TAG $list_of_services_to_rebuild
579 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100580 # The manifest for prometheus is prometheus.yaml or ng-prometheus.yaml, depending on the installation option
garciadeblas0e49b4a2023-04-17 12:38:17 +0200581 # If NG-SA is installed, it will include ng-mon (only mon-dashboarder), ng-prometheus and webhook translator. It won't include pol, mon and prometheus
garciadeblas7b53d262022-11-04 23:18:48 +0100582 if [ -n "$INSTALL_NGSA" ]; then
583 sudo rm -f ${OSM_K8S_WORK_DIR}/prometheus.yaml
garciadeblas0e49b4a2023-04-17 12:38:17 +0200584 sudo rm -f ${OSM_K8S_WORK_DIR}/mon.yaml
585 sudo rm -f ${OSM_K8S_WORK_DIR}/pol.yaml
garciadeblas7b53d262022-11-04 23:18:48 +0100586 else
garciadeblas0e49b4a2023-04-17 12:38:17 +0200587 sudo rm -f ${OSM_K8S_WORK_DIR}/ng-mon.yaml
garciadeblas7b53d262022-11-04 23:18:48 +0100588 sudo rm -f ${OSM_K8S_WORK_DIR}/ng-prometheus.yaml
garciadeblasbacdfa82023-04-04 10:52:46 +0200589 sudo rm -f ${OSM_K8S_WORK_DIR}/webhook-translator.yaml
garciadeblas7b53d262022-11-04 23:18:48 +0100590 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200591 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
vijaynag8339ed22019-07-25 17:10:58 +0530592}
593
594function namespace_vol() {
garciadeblas0bc87522021-10-20 22:16:17 +0200595 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas7b53d262022-11-04 23:18:48 +0100596 # List of services with a volume mounted in path /var/lib/osm
597 osm_services="mysql"
vijaynag8339ed22019-07-25 17:10:58 +0530598 for osm in $osm_services; do
garciadeblas7b53d262022-11-04 23:18:48 +0100599 if [ -f "$OSM_K8S_WORK_DIR/$osm.yaml" ] ; then
600 sudo sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_K8S_WORK_DIR/$osm.yaml
601 fi
vijaynag8339ed22019-07-25 17:10:58 +0530602 done
garciadeblas0bc87522021-10-20 22:16:17 +0200603 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas6c66abf2018-05-16 14:46:19 +0200604}
605
garciadeblase92a18d2020-07-03 16:24:23 +0000606function add_local_k8scluster() {
garciadeblas0bc87522021-10-20 22:16:17 +0200607 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblase92a18d2020-07-03 16:24:23 +0000608 /usr/bin/osm --all-projects vim-create \
609 --name _system-osm-vim \
610 --account_type dummy \
611 --auth_url http://dummy \
612 --user osm --password osm --tenant osm \
613 --description "dummy" \
614 --config '{management_network_name: mgmt}'
615 /usr/bin/osm --all-projects k8scluster-add \
616 --creds ${HOME}/.kube/config \
617 --vim _system-osm-vim \
618 --k8s-nets '{"net1": null}' \
619 --version '1.15' \
620 --description "OSM Internal Cluster" \
621 _system-osm-k8s
garciadeblas0bc87522021-10-20 22:16:17 +0200622 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblase92a18d2020-07-03 16:24:23 +0000623}
624
garciadeblas0bc87522021-10-20 22:16:17 +0200625function configure_apt_proxy() {
626 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
627 OSM_APT_PROXY=$1
628 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
629 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
630 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
631 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
632Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
633EOF"
634 else
635 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
636 fi
637 sudo apt-get update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas4d89c372021-11-25 11:57:18 +0100638 track prereq apt_proxy_configured_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200639 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
640}
641
garciadeblasfa3eb332022-11-15 14:11:56 +0100642function ask_proceed() {
garciadeblas0bc87522021-10-20 22:16:17 +0200643 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblasadcf95e2022-01-28 17:15:39 +0100644
garciadeblas0bc87522021-10-20 22:16:17 +0200645 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will do the following
646 1. Install and configure LXD
647 2. Install juju
648 3. Install docker CE
649 4. Disable swap space
650 5. Install and initialize Kubernetes
651 as pre-requirements.
652 Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
garciadeblasfa3eb332022-11-15 14:11:56 +0100653
654 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
655}
656
657function check_osm_behind_proxy() {
658 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
659
660 export OSM_BEHIND_PROXY=""
661 export OSM_PROXY_ENV_VARIABLES=""
662 [ -n "${http_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "http_proxy=${http_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} http_proxy"
663 [ -n "${https_proxy}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${https_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} https_proxy"
664 [ -n "${HTTP_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "HTTP_PROXY=${HTTP_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTP_PROXY"
665 [ -n "${HTTPS_PROXY}" ] && OSM_BEHIND_PROXY="y" && echo "https_proxy=${HTTPS_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} HTTPS_PROXY"
666 [ -n "${no_proxy}" ] && echo "no_proxy=${no_proxy}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} no_proxy"
667 [ -n "${NO_PROXY}" ] && echo "NO_PROXY=${NO_PROXY}" && OSM_PROXY_ENV_VARIABLES="${OSM_PROXY_ENV_VARIABLES} NO_PROXY"
668
669 echo "OSM_BEHIND_PROXY=${OSM_BEHIND_PROXY}"
670 echo "OSM_PROXY_ENV_VARIABLES=${OSM_PROXY_ENV_VARIABLES}"
671
672 if [ -n "${OSM_BEHIND_PROXY}" ]; then
673 [ -z "$ASSUME_YES" ] && ! ask_user "
674The following env variables have been found for the current user:
675${OSM_PROXY_ENV_VARIABLES}.
676
677This suggests that this machine is behind a proxy and a special configuration is required.
678The installer will install Docker CE, LXD and Juju to work behind a proxy using those
679env variables.
680
681Take into account that the installer uses apt, curl, wget, docker, lxd, juju and snap.
682Depending on the program, the env variables to work behind a proxy might be different
683(e.g. http_proxy vs HTTP_PROXY).
684
685For that reason, it is strongly recommended that at least http_proxy, https_proxy, HTTP_PROXY
686and HTTPS_PROXY are defined.
687
688Finally, some of the programs (apt, snap) those programs are run as sudoer, requiring that
689those env variables are also set for root user. If you are not sure whether those variables
690are configured for the root user, you can stop the installation now.
691
692Do you want to proceed with the installation (Y/n)? " y && echo "Cancelled!" && exit 1
693 else
694 echo "This machine is not behind a proxy"
695 fi
696
697 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
698}
699
700function find_devops_folder() {
701 if [ -z "$OSM_DEVOPS" ]; then
702 if [ -n "$TEST_INSTALLER" ]; then
703 echo -e "\nUsing local devops repo for OSM installation"
704 OSM_DEVOPS="$(dirname $(realpath $(dirname $0)))"
705 else
706 echo -e "\nCreating temporary dir for OSM installation"
707 OSM_DEVOPS="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
708 trap 'rm -rf "$OSM_DEVOPS"' EXIT
709 git clone https://osm.etsi.org/gerrit/osm/devops.git $OSM_DEVOPS
710 fi
711 fi
712}
713
714function install_osm() {
715 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
716
717 trap ctrl_c INT
718
719 # TODO: move this under start
720 [ -n "$DOCKER_REGISTRY_URL" ] && parse_docker_registry_url
721
722 check_osm_behind_proxy
723 track checks proxy_ok
724
725 check_packages "git wget curl tar snapd"
726
727 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
728
729 find_devops_folder
730
garciadeblasfa3eb332022-11-15 14:11:56 +0100731 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
732
733 track checks checkingroot_ok
734 [ "$USER" == "root" ] && FATAL "You are running the installer as root. The installer is prepared to be executed as a normal user with sudo privileges."
735 track checks noroot_ok
736
737 ask_proceed
garciadeblas4d89c372021-11-25 11:57:18 +0100738 track checks proceed_ok
vijaynag8339ed22019-07-25 17:10:58 +0530739
garciadeblas0bc87522021-10-20 22:16:17 +0200740 echo "Installing OSM"
741
742 echo "Determining IP address of the interface with the default route"
garciadeblas45ab04c2022-11-25 10:59:03 +0100743 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
744 [ -z "$OSM_DEFAULT_IF" ] && OSM_DEFAULT_IF=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
745 [ -z "$OSM_DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
746 OSM_DEFAULT_IP=`ip -o -4 a s ${OSM_DEFAULT_IF} |awk '{split($4,a,"/"); print a[1]; exit}'`
747 [ -z "$OSM_DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
garciadeblas0bc87522021-10-20 22:16:17 +0200748
749 # configure apt proxy
750 [ -n "$APT_PROXY_URL" ] && configure_apt_proxy $APT_PROXY_URL
Mike Marchettib8420852018-09-13 13:45:06 -0400751
752 # if no host is passed in, we need to install lxd/juju, unless explicilty asked not to
David Garcia79f4f532020-04-07 12:59:34 +0200753 if [ -z "$OSM_VCA_HOST" ] && [ -z "$INSTALL_NOLXD" ] && [ -z "$LXD_CLOUD_FILE" ]; then
garciadeblas45ab04c2022-11-25 10:59:03 +0100754 LXD_INSTALL_OPTS="-D ${OSM_DEVOPS} -i ${OSM_DEFAULT_IF} ${DEBUG_INSTALL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100755 [ -n "${OSM_BEHIND_PROXY}" ] && LXD_INSTALL_OPTS="${LXD_INSTALL_OPTS} -P"
garciadeblas8fed1082022-08-29 11:25:02 +0200756 $OSM_DEVOPS/installers/install_lxd.sh ${LXD_INSTALL_OPTS} || FATAL_TRACK lxd "install_lxd.sh failed"
garciadeblasd41f5482018-05-25 10:25:06 +0200757 fi
David Garcia79f4f532020-04-07 12:59:34 +0200758
garciadeblas4d89c372021-11-25 11:57:18 +0100759 track prereq prereqok_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400760
garciadeblas95804f82021-11-08 23:02:01 +0100761 if [ ! -n "$INSTALL_NODOCKER" ]; then
762 DOCKER_CE_OPTS="-D ${OSM_DEVOPS} ${DEBUG_INSTALL}"
763 [ -n "${DOCKER_PROXY_URL}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -p ${DOCKER_PROXY_URL}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100764 [ -n "${OSM_BEHIND_PROXY}" ] && DOCKER_CE_OPTS="${DOCKER_CE_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100765 $OSM_DEVOPS/installers/install_docker_ce.sh ${DOCKER_CE_OPTS} || FATAL_TRACK docker_ce "install_docker_ce.sh failed"
garciadeblas95804f82021-11-08 23:02:01 +0100766 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200767
garciadeblas4d89c372021-11-25 11:57:18 +0100768 track docker_ce docker_ce_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200769
770 echo "Creating folders for installation"
garciadeblas0bc87522021-10-20 22:16:17 +0200771 [ ! -d "$OSM_DOCKER_WORK_DIR" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR
772 [ ! -d "$OSM_DOCKER_WORK_DIR/osm_pla" -a -n "$INSTALL_PLA" ] && sudo mkdir -p $OSM_DOCKER_WORK_DIR/osm_pla
773 sudo cp -b $OSM_DEVOPS/installers/docker/cluster-config.yaml $OSM_DOCKER_WORK_DIR/cluster-config.yaml
David Garcia6cbfee12020-10-23 10:40:20 +0200774
garciadeblas45ab04c2022-11-25 10:59:03 +0100775 $OSM_DEVOPS/installers/install_kubeadm_cluster.sh -i ${OSM_DEFAULT_IP} -d ${OSM_DOCKER_WORK_DIR} -D ${OSM_DEVOPS} ${DEBUG_INSTALL} || \
garciadeblas4d89c372021-11-25 11:57:18 +0100776 FATAL_TRACK k8scluster "install_kubeadm_cluster.sh failed"
777 track k8scluster k8scluster_ok
David Garcia6cbfee12020-10-23 10:40:20 +0200778
garciadeblas325032a2023-04-13 18:07:44 +0200779 JUJU_OPTS="-D ${OSM_DEVOPS} -s ${OSM_NAMESPACE} -i ${OSM_DEFAULT_IP} ${DEBUG_INSTALL} ${INSTALL_NOJUJU} ${INSTALL_CACHELXDIMAGES}"
garciadeblas0bc87522021-10-20 22:16:17 +0200780 [ -n "${OSM_VCA_HOST}" ] && JUJU_OPTS="$JUJU_OPTS -H ${OSM_VCA_HOST}"
781 [ -n "${LXD_CLOUD_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -l ${LXD_CLOUD_FILE}"
782 [ -n "${LXD_CRED_FILE}" ] && JUJU_OPTS="$JUJU_OPTS -L ${LXD_CRED_FILE}"
783 [ -n "${CONTROLLER_NAME}" ] && JUJU_OPTS="$JUJU_OPTS -K ${CONTROLLER_NAME}"
garciadeblasfa3eb332022-11-15 14:11:56 +0100784 [ -n "${OSM_BEHIND_PROXY}" ] && JUJU_OPTS="${JUJU_OPTS} -P"
garciadeblas4d89c372021-11-25 11:57:18 +0100785 $OSM_DEVOPS/installers/install_juju.sh ${JUJU_OPTS} || FATAL_TRACK juju "install_juju.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200786 set_vca_variables
garciadeblas4d89c372021-11-25 11:57:18 +0100787 track juju juju_ok
Adam Israel5ddc97f2019-09-03 18:11:12 -0400788
Benjamin Diazba2cca92018-11-08 21:07:15 -0300789 if [ -z "$OSM_DATABASE_COMMONKEY" ]; then
790 OSM_DATABASE_COMMONKEY=$(generate_secret)
791 [ -z "OSM_DATABASE_COMMONKEY" ] && FATAL "Cannot generate common db secret"
792 fi
vijaynag8339ed22019-07-25 17:10:58 +0530793
David Garcia6cbfee12020-10-23 10:40:20 +0200794 # Deploy OSM services
garciadeblas53b217f2023-05-04 17:57:47 +0200795 [ -z "$DOCKER_NOBUILD" ] && pull_docker_images
796 [ -z "$DOCKER_NOBUILD" ] && [ -z "$PULL_IMAGES" ] && generate_docker_images
garciadeblas4d89c372021-11-25 11:57:18 +0100797 track docker_images docker_images_ok
vijaynag8339ed22019-07-25 17:10:58 +0530798
garciadeblas0bc87522021-10-20 22:16:17 +0200799 generate_k8s_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100800 track osm_files manifest_files_ok
garciadeblasd8bc5c32018-05-09 17:37:56 +0200801 generate_docker_env_files
garciadeblas4d89c372021-11-25 11:57:18 +0100802 track osm_files env_files_ok
Mike Marchettib8420852018-09-13 13:45:06 -0400803
garciadeblas0bc87522021-10-20 22:16:17 +0200804 deploy_charmed_services
garciadeblas4d89c372021-11-25 11:57:18 +0100805 track deploy_osm deploy_charmed_services_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200806 kube_secrets
garciadeblas4d89c372021-11-25 11:57:18 +0100807 track deploy_osm kube_secrets_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200808 update_manifest_files
garciadeblas4d89c372021-11-25 11:57:18 +0100809 track deploy_osm update_manifest_files_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200810 namespace_vol
garciadeblas4d89c372021-11-25 11:57:18 +0100811 track deploy_osm namespace_vol_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200812 deploy_osm_services
garciadeblas4d89c372021-11-25 11:57:18 +0100813 track deploy_osm deploy_osm_services_k8s_ok
garciadeblas7b53d262022-11-04 23:18:48 +0100814 if [ -n "$INSTALL_PLA" ]; then
garciadeblas0bc87522021-10-20 22:16:17 +0200815 # optional PLA install
816 deploy_osm_pla_service
garciadeblas4d89c372021-11-25 11:57:18 +0100817 track deploy_osm deploy_osm_pla_ok
garciadeblas0bc87522021-10-20 22:16:17 +0200818 fi
garciadeblas0bc87522021-10-20 22:16:17 +0200819 if [ -n "$INSTALL_K8S_MONITOR" ]; then
820 # install OSM MONITORING
821 install_k8s_monitoring
garciadeblas4d89c372021-11-25 11:57:18 +0100822 track deploy_osm install_k8s_monitoring_ok
vijaynag8339ed22019-07-25 17:10:58 +0530823 fi
garciadeblas7b53d262022-11-04 23:18:48 +0100824 if [ -n "$INSTALL_NGSA" ]; then
825 # optional PLA install
826 install_osm_ngsa_service
827 track deploy_osm install_osm_ngsa_ok
828 fi
vijaynag8339ed22019-07-25 17:10:58 +0530829
Mike Marchettib8420852018-09-13 13:45:06 -0400830 [ -z "$INSTALL_NOHOSTCLIENT" ] && install_osmclient
garciadeblas4d89c372021-11-25 11:57:18 +0100831 track osmclient osmclient_ok
beierlma4a37f72020-06-26 12:55:01 -0400832
garciadeblas4a9adcd2020-07-03 15:32:05 +0000833 echo -e "Checking OSM health state..."
garciadeblas325032a2023-04-13 18:07:44 +0200834 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_NAMESPACE} -k || \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100835 (echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
garciadeblas325032a2023-04-13 18:07:44 +0200836 echo -e "Check OSM status with: kubectl -n ${OSM_NAMESPACE} get all" && \
garciadeblasf4f0e0f2021-12-03 11:37:40 +0100837 track healthchecks osm_unhealthy didnotconverge)
garciadeblas4d89c372021-11-25 11:57:18 +0100838 track healthchecks after_healthcheck_ok
vijaynag8339ed22019-07-25 17:10:58 +0530839
garciadeblas0bc87522021-10-20 22:16:17 +0200840 add_local_k8scluster
garciadeblas4d89c372021-11-25 11:57:18 +0100841 track final_ops add_local_k8scluster_ok
garciadeblase92a18d2020-07-03 16:24:23 +0000842
Gulsum Atici3d3a7672023-02-01 11:15:52 +0300843 arrange_docker_default_network_policy
Gulsum Atici5e263302023-01-30 19:11:31 +0300844
garciadeblas89c5f552022-11-24 20:16:57 +0100845 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
garciadeblas6c66abf2018-05-16 14:46:19 +0200846 track end
garciadeblas0bc87522021-10-20 22:16:17 +0200847 sudo find /etc/osm
848 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200849 return 0
850}
851
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200852function install_to_openstack() {
garciadeblas0bc87522021-10-20 22:16:17 +0200853 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200854
855 if [ -z "$2" ]; then
856 FATAL "OpenStack installer requires a valid external network name"
857 fi
858
859 # Install Pip for Python3
garciadeblas0bc87522021-10-20 22:16:17 +0200860 sudo apt install -y python3-pip python3-venv
861 sudo -H LC_ALL=C python3 -m pip install -U pip
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200862
Antonio Marsico75a38c72020-12-21 17:29:42 +0100863 # Create a venv to avoid conflicts with the host installation
864 python3 -m venv $OPENSTACK_PYTHON_VENV
865
866 source $OPENSTACK_PYTHON_VENV/bin/activate
867
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100868 # Install Ansible, OpenStack client and SDK, latest openstack version supported is Train
Antonio Marsico75a38c72020-12-21 17:29:42 +0100869 python -m pip install -U wheel
Antonio Marsicoef3b2362021-03-19 18:54:57 +0100870 python -m pip install -U "python-openstackclient<=4.0.2" "openstacksdk>=0.12.0,<=0.36.2" "ansible>=2.10,<2.11"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100871
872 # Install the Openstack cloud module (ansible>=2.10)
873 ansible-galaxy collection install openstack.cloud
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200874
875 export ANSIBLE_CONFIG="$OSM_DEVOPS/installers/openstack/ansible.cfg"
876
877 OSM_INSTALLER_ARGS="${REPO_ARGS[@]}"
878
Antonio Marsico75a38c72020-12-21 17:29:42 +0100879 ANSIBLE_VARS="external_network_name=$2 setup_volume=$3 server_name=$OPENSTACK_VM_NAME"
880
881 if [ -n "$OPENSTACK_SSH_KEY_FILE" ]; then
882 ANSIBLE_VARS+=" key_file=$OPENSTACK_SSH_KEY_FILE"
883 fi
884
885 if [ -n "$OPENSTACK_USERDATA_FILE" ]; then
886 ANSIBLE_VARS+=" userdata_file=$OPENSTACK_USERDATA_FILE"
887 fi
888
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200889 # Execute the Ansible playbook based on openrc or clouds.yaml
890 if [ -e "$1" ]; then
891 . $1
Antonio Marsico75a38c72020-12-21 17:29:42 +0100892 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
893 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200894 else
Antonio Marsico75a38c72020-12-21 17:29:42 +0100895 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
896 -e cloud_name=$1 $OSM_DEVOPS/installers/openstack/site.yml
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200897 fi
898
Antonio Marsico75a38c72020-12-21 17:29:42 +0100899 # Exit from venv
900 deactivate
901
garciadeblas0bc87522021-10-20 22:16:17 +0200902 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200903 return 0
904}
905
Gulsum Atici3d3a7672023-02-01 11:15:52 +0300906function arrange_docker_default_network_policy() {
907 echo -e "Fixing firewall so docker and LXD can share the same host without affecting each other."
908 sudo iptables -I DOCKER-USER -j ACCEPT
909 sudo iptables-save | sudo tee /etc/iptables/rules.v4
910 sudo ip6tables-save | sudo tee /etc/iptables/rules.v6
911}
912
romeromonsere366b1a2019-11-19 19:49:26 +0100913function install_k8s_monitoring() {
garciadeblas0bc87522021-10-20 22:16:17 +0200914 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
romeromonsere366b1a2019-11-19 19:49:26 +0100915 # install OSM monitoring
garciadeblas0bc87522021-10-20 22:16:17 +0200916 sudo chmod +x $OSM_DEVOPS/installers/k8s/*.sh
garciadeblas4d89c372021-11-25 11:57:18 +0100917 sudo $OSM_DEVOPS/installers/k8s/install_osm_k8s_monitoring.sh || FATAL_TRACK install_k8s_monitoring "k8s/install_osm_k8s_monitoring.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +0200918 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
romeromonsere366b1a2019-11-19 19:49:26 +0100919}
920
garciadeblasd8bc5c32018-05-09 17:37:56 +0200921function dump_vars(){
garciadeblas0bc87522021-10-20 22:16:17 +0200922 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
923 echo "APT_PROXY_URL=$APT_PROXY_URL"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200924 echo "DEVELOP=$DEVELOP"
garciadeblas0bc87522021-10-20 22:16:17 +0200925 echo "DEBUG_INSTALL=$DEBUG_INSTALL"
926 echo "DOCKER_NOBUILD=$DOCKER_NOBUILD"
927 echo "DOCKER_PROXY_URL=$DOCKER_PROXY_URL"
928 echo "DOCKER_REGISTRY_URL=$DOCKER_REGISTRY_URL"
929 echo "DOCKER_USER=$DOCKER_USER"
930 echo "INSTALL_CACHELXDIMAGES=$INSTALL_CACHELXDIMAGES"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200931 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
garciadeblas0bc87522021-10-20 22:16:17 +0200932 echo "INSTALL_K8S_MONITOR=$INSTALL_K8S_MONITOR"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200933 echo "INSTALL_LIGHTWEIGHT=$INSTALL_LIGHTWEIGHT"
garciadeblas0bc87522021-10-20 22:16:17 +0200934 echo "INSTALL_LXD=$INSTALL_LXD"
garciadeblas7b53d262022-11-04 23:18:48 +0100935 echo "INSTALL_NGSA=$INSTALL_NGSA"
garciadeblas0bc87522021-10-20 22:16:17 +0200936 echo "INSTALL_NODOCKER=$INSTALL_NODOCKER"
937 echo "INSTALL_NOJUJU=$INSTALL_NOJUJU"
938 echo "INSTALL_NOLXD=$INSTALL_NOLXD"
garciadeblas6c66abf2018-05-16 14:46:19 +0200939 echo "INSTALL_ONLY=$INSTALL_ONLY"
garciadeblas0bc87522021-10-20 22:16:17 +0200940 echo "INSTALL_PLA=$INSTALL_PLA"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200941 echo "INSTALL_TO_OPENSTACK=$INSTALL_TO_OPENSTACK"
garciadeblas0bc87522021-10-20 22:16:17 +0200942 echo "INSTALL_VIMEMU=$INSTALL_VIMEMU"
943 echo "NO_HOST_PORTS=$NO_HOST_PORTS"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +0200944 echo "OPENSTACK_PUBLIC_NET_NAME=$OPENSTACK_PUBLIC_NET_NAME"
945 echo "OPENSTACK_OPENRC_FILE_OR_CLOUD=$OPENSTACK_OPENRC_FILE_OR_CLOUD"
946 echo "OPENSTACK_ATTACH_VOLUME=$OPENSTACK_ATTACH_VOLUME"
Antonio Marsico75a38c72020-12-21 17:29:42 +0100947 echo "OPENSTACK_SSH_KEY_FILE"="$OPENSTACK_SSH_KEY_FILE"
948 echo "OPENSTACK_USERDATA_FILE"="$OPENSTACK_USERDATA_FILE"
949 echo "OPENSTACK_VM_NAME"="$OPENSTACK_VM_NAME"
garciadeblas0bc87522021-10-20 22:16:17 +0200950 echo "OSM_DEVOPS=$OSM_DEVOPS"
951 echo "OSM_DOCKER_TAG=$OSM_DOCKER_TAG"
garciadeblas0cd9b882022-02-10 03:11:50 +0100952 echo "OSM_DOCKER_WORK_DIR=$OSM_DOCKER_WORK_DIR"
garciadeblas7b53d262022-11-04 23:18:48 +0100953 echo "OSM_HELM_WORK_DIR=$OSM_HELM_WORK_DIR"
garciadeblas0cd9b882022-02-10 03:11:50 +0100954 echo "OSM_K8S_WORK_DIR=$OSM_K8S_WORK_DIR"
garciadeblas325032a2023-04-13 18:07:44 +0200955 echo "OSM_NAMESPACE=$OSM_NAMESPACE"
garciadeblas0bc87522021-10-20 22:16:17 +0200956 echo "OSM_VCA_HOST=$OSM_VCA_HOST"
957 echo "OSM_VCA_PUBKEY=$OSM_VCA_PUBKEY"
958 echo "OSM_VCA_SECRET=$OSM_VCA_SECRET"
959 echo "OSM_WORK_DIR=$OSM_WORK_DIR"
960 echo "PULL_IMAGES=$PULL_IMAGES"
961 echo "RECONFIGURE=$RECONFIGURE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200962 echo "RELEASE=$RELEASE"
963 echo "REPOSITORY=$REPOSITORY"
964 echo "REPOSITORY_BASE=$REPOSITORY_BASE"
965 echo "REPOSITORY_KEY=$REPOSITORY_KEY"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200966 echo "SHOWOPTS=$SHOWOPTS"
garciadeblas0bc87522021-10-20 22:16:17 +0200967 echo "TEST_INSTALLER=$TEST_INSTALLER"
968 echo "TO_REBUILD=$TO_REBUILD"
969 echo "UNINSTALL=$UNINSTALL"
970 echo "UPDATE=$UPDATE"
garciadeblasd8bc5c32018-05-09 17:37:56 +0200971 echo "Install from specific refspec (-b): $COMMIT_ID"
garciadeblas0bc87522021-10-20 22:16:17 +0200972 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblasd8bc5c32018-05-09 17:37:56 +0200973}
974
garciadeblas453d4582020-12-16 19:03:10 +0100975function parse_docker_registry_url() {
garciadeblas0bc87522021-10-20 22:16:17 +0200976 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
garciadeblas453d4582020-12-16 19:03:10 +0100977 DOCKER_REGISTRY_USER=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[1]}')
978 DOCKER_REGISTRY_PASSWORD=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[2]}')
979 DOCKER_REGISTRY_URL=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); print a[2]}')
garciadeblas0bc87522021-10-20 22:16:17 +0200980 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
garciadeblas453d4582020-12-16 19:03:10 +0100981}
982
garciadeblasadcf95e2022-01-28 17:15:39 +0100983function ctrl_c() {
984 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
985 echo "** Trapped CTRL-C"
986 FATAL "User stopped the installation"
987 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
988}
989
garciadeblasd8bc5c32018-05-09 17:37:56 +0200990UNINSTALL=""
991DEVELOP=""
garciadeblasd8bc5c32018-05-09 17:37:56 +0200992UPDATE=""
993RECONFIGURE=""
994TEST_INSTALLER=""
995INSTALL_LXD=""
996SHOWOPTS=""
997COMMIT_ID=""
998ASSUME_YES=""
garciadeblas0bc87522021-10-20 22:16:17 +0200999APT_PROXY_URL=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001000INSTALL_FROM_SOURCE=""
garciadeblas0bc87522021-10-20 22:16:17 +02001001DEBUG_INSTALL=""
garciadeblas00627272021-05-26 16:54:05 +02001002RELEASE="ReleaseTEN"
Mike Marchettib8420852018-09-13 13:45:06 -04001003REPOSITORY="stable"
garciadeblasfa3eb332022-11-15 14:11:56 +01001004INSTALL_K8S_MONITOR=""
garciadeblas7b53d262022-11-04 23:18:48 +01001005INSTALL_NGSA=""
garciadeblasfa3eb332022-11-15 14:11:56 +01001006INSTALL_PLA=""
1007INSTALL_VIMEMU=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001008LXD_REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/lxd"
1009LXD_REPOSITORY_PATH=""
1010INSTALL_LIGHTWEIGHT="y"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001011INSTALL_TO_OPENSTACK=""
1012OPENSTACK_OPENRC_FILE_OR_CLOUD=""
1013OPENSTACK_PUBLIC_NET_NAME=""
1014OPENSTACK_ATTACH_VOLUME="false"
Antonio Marsico75a38c72020-12-21 17:29:42 +01001015OPENSTACK_SSH_KEY_FILE=""
1016OPENSTACK_USERDATA_FILE=""
1017OPENSTACK_VM_NAME="server-osm"
1018OPENSTACK_PYTHON_VENV="$HOME/.virtual-envs/osm"
garciadeblas6c66abf2018-05-16 14:46:19 +02001019INSTALL_ONLY=""
garciadeblas0e596bc2018-05-28 16:04:42 +02001020TO_REBUILD=""
garciadeblasd41f5482018-05-25 10:25:06 +02001021INSTALL_NOLXD=""
garciadeblasa3e26612018-05-30 17:58:55 +02001022INSTALL_NODOCKER=""
Mike Marchettib8420852018-09-13 13:45:06 -04001023INSTALL_NOJUJU=""
garciadeblas0d45bc82018-11-19 14:25:13 +01001024INSTALL_NOHOSTCLIENT=""
garciadeblas0bc87522021-10-20 22:16:17 +02001025INSTALL_CACHELXDIMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001026OSM_DEVOPS=
lavadoe07b1642018-10-25 10:58:34 -05001027OSM_VCA_HOST=
1028OSM_VCA_SECRET=
garciadeblasaa3ddf42019-04-04 19:04:32 +02001029OSM_VCA_PUBKEY=
David Garcia79f4f532020-04-07 12:59:34 +02001030OSM_VCA_CLOUDNAME="localhost"
beierlma4a37f72020-06-26 12:55:01 -04001031OSM_VCA_K8S_CLOUDNAME="k8scloud"
garciadeblas325032a2023-04-13 18:07:44 +02001032OSM_NAMESPACE=osm
Mike Marchettib8420852018-09-13 13:45:06 -04001033NO_HOST_PORTS=""
1034DOCKER_NOBUILD=""
1035REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
garciadeblas870e60a2018-11-21 16:44:21 +01001036REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/debian"
Mike Marchettib8420852018-09-13 13:45:06 -04001037OSM_WORK_DIR="/etc/osm"
garciadeblas7b53d262022-11-04 23:18:48 +01001038OSM_DOCKER_WORK_DIR="${OSM_WORK_DIR}/docker"
vijaynag8339ed22019-07-25 17:10:58 +05301039OSM_K8S_WORK_DIR="${OSM_DOCKER_WORK_DIR}/osm_pods"
garciadeblas7b53d262022-11-04 23:18:48 +01001040OSM_HELM_WORK_DIR="${OSM_WORK_DIR}/helm"
vijaynag8339ed22019-07-25 17:10:58 +05301041OSM_HOST_VOL="/var/lib/osm"
garciadeblas325032a2023-04-13 18:07:44 +02001042OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_NAMESPACE}"
Mike Marchetti13d76c82018-09-19 15:00:36 -04001043OSM_DOCKER_TAG=latest
garciadeblas0d45bc82018-11-19 14:25:13 +01001044DOCKER_USER=opensourcemano
1045PULL_IMAGES="y"
Benjamin Diazaa0af712018-10-04 14:02:34 -03001046KAFKA_TAG=2.11-1.0.2
garciadeblas0ab16612022-02-22 14:23:57 +01001047KIWIGRID_K8S_SIDECAR_TAG="1.15.6"
1048PROMETHEUS_TAG=v2.28.1
1049GRAFANA_TAG=8.1.1
lavado6ad812e2019-11-29 10:58:58 -05001050PROMETHEUS_NODE_EXPORTER_TAG=0.18.1
1051PROMETHEUS_CADVISOR_TAG=latest
lavado9a8df7c2018-10-24 09:35:34 -05001052KEYSTONEDB_TAG=10
Benjamin Diazba2cca92018-11-08 21:07:15 -03001053OSM_DATABASE_COMMONKEY=
lavado53eb8f52018-11-16 12:58:23 -05001054ELASTIC_VERSION=6.4.2
lavado4e8662c2018-11-28 11:28:14 -05001055ELASTIC_CURATOR_VERSION=5.5.4
vijaynag8339ed22019-07-25 17:10:58 +05301056POD_NETWORK_CIDR=10.244.0.0/16
1057K8S_MANIFEST_DIR="/etc/kubernetes/manifests"
1058RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
garciadeblas7f1e1042020-11-30 14:07:03 +00001059DOCKER_REGISTRY_URL=
1060DOCKER_PROXY_URL=
1061MODULE_DOCKER_TAG=
garciadeblas4d89c372021-11-25 11:57:18 +01001062OSM_INSTALLATION_TYPE="Default"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001063
garciadeblas0bc87522021-10-20 22:16:17 +02001064while getopts ":a:b:r:n:k:u:R:D:o:O:m:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:-: hy" o; do
garciadeblasd8bc5c32018-05-09 17:37:56 +02001065 case "${o}" in
garciadeblas0bc87522021-10-20 22:16:17 +02001066 a)
1067 APT_PROXY_URL=${OPTARG}
1068 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001069 b)
1070 COMMIT_ID=${OPTARG}
garciadeblas0d45bc82018-11-19 14:25:13 +01001071 PULL_IMAGES=""
garciadeblasd8bc5c32018-05-09 17:37:56 +02001072 ;;
1073 r)
Mike Marchettib8420852018-09-13 13:45:06 -04001074 REPOSITORY="${OPTARG}"
1075 REPO_ARGS+=(-r "$REPOSITORY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001076 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001077 k)
Mike Marchettib8420852018-09-13 13:45:06 -04001078 REPOSITORY_KEY="${OPTARG}"
1079 REPO_ARGS+=(-k "$REPOSITORY_KEY")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001080 ;;
1081 u)
Mike Marchettib8420852018-09-13 13:45:06 -04001082 REPOSITORY_BASE="${OPTARG}"
1083 REPO_ARGS+=(-u "$REPOSITORY_BASE")
garciadeblasd8bc5c32018-05-09 17:37:56 +02001084 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001085 R)
1086 RELEASE="${OPTARG}"
1087 REPO_ARGS+=(-R "$RELEASE")
garciadeblas0d45bc82018-11-19 14:25:13 +01001088 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001089 D)
1090 OSM_DEVOPS="${OPTARG}"
1091 ;;
garciadeblas6c66abf2018-05-16 14:46:19 +02001092 o)
1093 INSTALL_ONLY="y"
garciadeblasb5a630f2020-03-05 18:32:16 +00001094 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblasfa3eb332022-11-15 14:11:56 +01001095 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
garciadeblas6c66abf2018-05-16 14:46:19 +02001096 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001097 O)
1098 INSTALL_TO_OPENSTACK="y"
1099 if [ -n "${OPTARG}" ]; then
1100 OPENSTACK_OPENRC_FILE_OR_CLOUD="${OPTARG}"
1101 else
1102 echo -e "Invalid argument for -O : ' $OPTARG'\n" >&2
1103 usage && exit 1
1104 fi
1105 ;;
Antonio Marsico75a38c72020-12-21 17:29:42 +01001106 f)
1107 OPENSTACK_SSH_KEY_FILE="${OPTARG}"
1108 ;;
1109 F)
1110 OPENSTACK_USERDATA_FILE="${OPTARG}"
1111 ;;
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001112 N)
1113 OPENSTACK_PUBLIC_NET_NAME="${OPTARG}"
1114 ;;
garciadeblas0e596bc2018-05-28 16:04:42 +02001115 m)
garciadeblas7f1e1042020-11-30 14:07:03 +00001116 [ "${OPTARG}" == "NG-UI" ] && TO_REBUILD="$TO_REBUILD NG-UI" && continue
govindappa79e51b92019-05-22 12:15:21 +05301117 [ "${OPTARG}" == "NBI" ] && TO_REBUILD="$TO_REBUILD NBI" && continue
1118 [ "${OPTARG}" == "LCM" ] && TO_REBUILD="$TO_REBUILD LCM" && continue
1119 [ "${OPTARG}" == "RO" ] && TO_REBUILD="$TO_REBUILD RO" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001120 [ "${OPTARG}" == "MON" ] && TO_REBUILD="$TO_REBUILD MON" && continue
govindappa79e51b92019-05-22 12:15:21 +05301121 [ "${OPTARG}" == "POL" ] && TO_REBUILD="$TO_REBUILD POL" && continue
garciadeblas7f1e1042020-11-30 14:07:03 +00001122 [ "${OPTARG}" == "PLA" ] && TO_REBUILD="$TO_REBUILD PLA" && continue
1123 [ "${OPTARG}" == "osmclient" ] && TO_REBUILD="$TO_REBUILD osmclient" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001124 [ "${OPTARG}" == "KAFKA" ] && TO_REBUILD="$TO_REBUILD KAFKA" && continue
1125 [ "${OPTARG}" == "MONGO" ] && TO_REBUILD="$TO_REBUILD MONGO" && continue
govindappa79e51b92019-05-22 12:15:21 +05301126 [ "${OPTARG}" == "PROMETHEUS" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS" && continue
garciadeblasfc5bb142019-12-10 10:49:12 +01001127 [ "${OPTARG}" == "PROMETHEUS-CADVISOR" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS-CADVISOR" && continue
govindappa79e51b92019-05-22 12:15:21 +05301128 [ "${OPTARG}" == "KEYSTONE-DB" ] && TO_REBUILD="$TO_REBUILD KEYSTONE-DB" && continue
lavado6ad812e2019-11-29 10:58:58 -05001129 [ "${OPTARG}" == "GRAFANA" ] && TO_REBUILD="$TO_REBUILD GRAFANA" && continue
garciadeblas0e596bc2018-05-28 16:04:42 +02001130 [ "${OPTARG}" == "NONE" ] && TO_REBUILD="$TO_REBUILD NONE" && continue
1131 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001132 H)
1133 OSM_VCA_HOST="${OPTARG}"
1134 ;;
1135 S)
1136 OSM_VCA_SECRET="${OPTARG}"
1137 ;;
1138 s)
garciadeblas325032a2023-04-13 18:07:44 +02001139 OSM_NAMESPACE="${OPTARG}" && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
garciadeblas25e87d22020-01-31 14:27:29 +01001140 ;;
1141 t)
1142 OSM_DOCKER_TAG="${OPTARG}"
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001143 REPO_ARGS+=(-t "$OSM_DOCKER_TAG")
garciadeblas25e87d22020-01-31 14:27:29 +01001144 ;;
1145 U)
1146 DOCKER_USER="${OPTARG}"
1147 ;;
1148 P)
1149 OSM_VCA_PUBKEY=$(cat ${OPTARG})
1150 ;;
1151 A)
1152 OSM_VCA_APIPROXY="${OPTARG}"
1153 ;;
David Garcia79f4f532020-04-07 12:59:34 +02001154 l)
1155 LXD_CLOUD_FILE="${OPTARG}"
1156 ;;
1157 L)
1158 LXD_CRED_FILE="${OPTARG}"
1159 ;;
David Garcia404ae122020-04-28 11:47:55 +02001160 K)
1161 CONTROLLER_NAME="${OPTARG}"
1162 ;;
garciadeblas7f1e1042020-11-30 14:07:03 +00001163 d)
1164 DOCKER_REGISTRY_URL="${OPTARG}"
1165 ;;
1166 p)
1167 DOCKER_PROXY_URL="${OPTARG}"
1168 ;;
1169 T)
1170 MODULE_DOCKER_TAG="${OPTARG}"
1171 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001172 -)
1173 [ "${OPTARG}" == "help" ] && usage && exit 0
garciadeblas0d45bc82018-11-19 14:25:13 +01001174 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && PULL_IMAGES="" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001175 [ "${OPTARG}" == "debug" ] && DEBUG_INSTALL="--debug" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001176 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
1177 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001178 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
1179 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
1180 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
1181 [ "${OPTARG}" == "lxdinstall" ] && INSTALL_LXD="y" && continue
garciadeblasd41f5482018-05-25 10:25:06 +02001182 [ "${OPTARG}" == "nolxd" ] && INSTALL_NOLXD="y" && continue
garciadeblasa3e26612018-05-30 17:58:55 +02001183 [ "${OPTARG}" == "nodocker" ] && INSTALL_NODOCKER="y" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001184 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001185 [ "${OPTARG}" == "nohostports" ] && NO_HOST_PORTS="y" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001186 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="--nojuju" && continue
Mike Marchettib8420852018-09-13 13:45:06 -04001187 [ "${OPTARG}" == "nodockerbuild" ] && DOCKER_NOBUILD="y" && continue
1188 [ "${OPTARG}" == "nohostclient" ] && INSTALL_NOHOSTCLIENT="y" && continue
garciadeblas0d45bc82018-11-19 14:25:13 +01001189 [ "${OPTARG}" == "pullimages" ] && continue
garciadeblasb5a630f2020-03-05 18:32:16 +00001190 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
garciadeblas4d89c372021-11-25 11:57:18 +01001191 [ "${OPTARG}" == "charmed" ] && CHARMED="y" && OSM_INSTALLATION_TYPE="Charmed" && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001192 [ "${OPTARG}" == "bundle" ] && continue
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +02001193 [ "${OPTARG}" == "k8s" ] && continue
1194 [ "${OPTARG}" == "lxd" ] && continue
1195 [ "${OPTARG}" == "lxd-cred" ] && continue
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001196 [ "${OPTARG}" == "microstack" ] && continue
David Garcia4bd2bf02021-05-05 19:01:43 +02001197 [ "${OPTARG}" == "overlay" ] && continue
David Garcia1bc71022021-05-03 18:27:18 +02001198 [ "${OPTARG}" == "only-vca" ] && continue
aticig5d19ac22022-05-06 13:46:22 +03001199 [ "${OPTARG}" == "small-profile" ] && continue
Dominik Fleischmannc63bed62020-09-25 12:17:54 +02001200 [ "${OPTARG}" == "vca" ] && continue
Dominik Fleischmannc57296f2020-06-09 11:45:08 +02001201 [ "${OPTARG}" == "ha" ] && continue
David Garcia69388c22020-05-07 12:14:19 +02001202 [ "${OPTARG}" == "tag" ] && continue
beierlmf2782c52020-11-05 17:04:05 -05001203 [ "${OPTARG}" == "registry" ] && continue
magnussonl1bbe9452020-02-25 13:43:17 +01001204 [ "${OPTARG}" == "pla" ] && INSTALL_PLA="y" && continue
garciadeblas7b53d262022-11-04 23:18:48 +01001205 [ "${OPTARG}" == "ng-sa" ] && INSTALL_NGSA="y" && continue
Antonio Marsicof4ce57c2020-04-23 12:06:19 +02001206 [ "${OPTARG}" == "volume" ] && OPENSTACK_ATTACH_VOLUME="true" && continue
garciadeblas0bc87522021-10-20 22:16:17 +02001207 [ "${OPTARG}" == "nocachelxdimages" ] && continue
1208 [ "${OPTARG}" == "cachelxdimages" ] && INSTALL_CACHELXDIMAGES="--cachelxdimages" && continue
garciadeblasd8bc5c32018-05-09 17:37:56 +02001209 echo -e "Invalid option: '--$OPTARG'\n" >&2
1210 usage && exit 1
1211 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001212 :)
1213 echo "Option -$OPTARG requires an argument" >&2
1214 usage && exit 1
1215 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001216 \?)
1217 echo -e "Invalid option: '-$OPTARG'\n" >&2
1218 usage && exit 1
1219 ;;
garciadeblas25e87d22020-01-31 14:27:29 +01001220 h)
1221 usage && exit 0
1222 ;;
garciadeblasd8bc5c32018-05-09 17:37:56 +02001223 y)
1224 ASSUME_YES="y"
1225 ;;
1226 *)
1227 usage && exit 1
1228 ;;
1229 esac
1230done
1231
garciadeblas0bc87522021-10-20 22:16:17 +02001232source $OSM_DEVOPS/common/all_funcs
garciadeblas6c66abf2018-05-16 14:46:19 +02001233
garciadeblas0bc87522021-10-20 22:16:17 +02001234[ -z "${DEBUG_INSTALL}" ] || DEBUG Debug is on
1235[ -n "$SHOWOPTS" ] && dump_vars && exit 0
1236
1237# Uninstall if "--uninstall"
1238if [ -n "$UNINSTALL" ]; then
1239 if [ -n "$CHARMED" ]; then
garciadeblas4d89c372021-11-25 11:57:18 +01001240 ${OSM_DEVOPS}/installers/charmed_uninstall.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $OSM_DEVOPS -t $DOCKER_TAG "$@" || \
1241 FATAL_TRACK charmed_uninstall "charmed_uninstall.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001242 else
garciadeblas4d89c372021-11-25 11:57:18 +01001243 ${OSM_DEVOPS}/installers/uninstall_osm.sh "$@" || \
1244 FATAL_TRACK community_uninstall "uninstall_osm.sh failed"
garciadeblas0bc87522021-10-20 22:16:17 +02001245 fi
1246 echo -e "\nDONE"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001247 exit 0
1248fi
1249
garciadeblas0bc87522021-10-20 22:16:17 +02001250# Charmed installation
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001251if [ -n "$CHARMED" ]; then
Mark Beierl70d6f3a2022-12-12 09:00:59 -05001252 sudo snap install jq || FATAL "Could not install jq (snap package). Make sure that snap works"
beierlmce7b4602022-04-13 08:19:40 -04001253 export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
1254 track start release $RELEASE none none docker_tag $OSM_DOCKER_TAG none none installation_type $OSM_INSTALLATION_TYPE none none
1255 ${OSM_DEVOPS}/installers/charmed_install.sh --tag $OSM_DOCKER_TAG "$@" || \
garciadeblas4d89c372021-11-25 11:57:18 +01001256 FATAL_TRACK charmed_install "charmed_install.sh failed"
garciadeblas89c5f552022-11-24 20:16:57 +01001257 wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README2.txt &> /dev/null
beierlmce7b4602022-04-13 08:19:40 -04001258 track end installation_type $OSM_INSTALLATION_TYPE
garciadeblas0bc87522021-10-20 22:16:17 +02001259 echo -e "\nDONE"
1260 exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +01001261fi
1262
garciadeblas0bc87522021-10-20 22:16:17 +02001263# Installation to Openstack
1264if [ -n "$INSTALL_TO_OPENSTACK" ]; then
1265 install_to_openstack $OPENSTACK_OPENRC_FILE_OR_CLOUD $OPENSTACK_PUBLIC_NET_NAME $OPENSTACK_ATTACH_VOLUME
1266 echo -e "\nDONE"
1267 exit 0
1268fi
1269
1270# Community_installer
garciadeblasfa3eb332022-11-15 14:11:56 +01001271
garciadeblas0bc87522021-10-20 22:16:17 +02001272[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" != " NONE" ] && echo $TO_REBUILD | grep -q NONE && FATAL "Incompatible option: -m NONE cannot be used with other -m options"
1273[ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" == " PLA" ] && [ -z "$INSTALL_PLA" ] && FATAL "Incompatible option: -m PLA cannot be used without --pla option"
garciadeblasd8bc5c32018-05-09 17:37:56 +02001274# if develop, we force master
1275[ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
garciadeblas325032a2023-04-13 18:07:44 +02001276OSM_K8S_WORK_DIR="$OSM_DOCKER_WORK_DIR/osm_pods" && OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_NAMESPACE}"
garciadeblasb5a630f2020-03-05 18:32:16 +00001277[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_K8S_MONITOR" ] && install_k8s_monitoring
garciadeblasfa3eb332022-11-15 14:11:56 +01001278[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_NGSA" ] && install_osm_ngsa_service
garciadeblas6c66abf2018-05-16 14:46:19 +02001279[ -n "$INSTALL_ONLY" ] && echo -e "\nDONE" && exit 0
garciadeblasd8bc5c32018-05-09 17:37:56 +02001280
1281#Installation starts here
garciadeblas89c5f552022-11-24 20:16:57 +01001282wget -q -O- https://osm-download.etsi.org/ftp/osm-13.0-thirteen/README.txt &> /dev/null
garciadeblas4d89c372021-11-25 11:57:18 +01001283export OSM_TRACK_INSTALLATION_ID="$(date +%s)-$(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 16)"
garciadeblas0bc87522021-10-20 22:16:17 +02001284install_osm
garciadeblasd8bc5c32018-05-09 17:37:56 +02001285echo -e "\nDONE"
garciadeblas4d89c372021-11-25 11:57:18 +01001286exit 0